// ------------------------------------------------------------
// - La programmation orientee aspect pour Java/J2EE          -
// - Renaud Pawlak, Jean-Philippe Retaille, Lionel Seinturier -
// - Editions Eyrolles                                        -
// -                                                          -
// - Partie II  : Les outils de la POA                        -
// - Chapitre 4 : JAC                                         -
// ------------------------------------------------------------

package aop.jac;

/**
 * Dans l'application Gestion de commandes,
 * cette classe represente l'activite d'un client
 * qui achete 1 DVD et 2 CD,
 * puis demande le calcul du montant de la commande.
 * 
 * @author Renaud Pawlak
 * @author Jean-Philippe Retaille
 * @author Lionel Seinturier
 */
public class Customer {
    
    /**
     * L'activite du client.
     */
    public void run() {
        Order maCommande = new Order();
        maCommande.addItem("DVD",1);
        maCommande.addItem("CD",2);
        double montant = maCommande.computeAmount();
        System.out.println("Montant de la commande : "+montant+" euros");
    }
    
    public static void main(String[] args) {
        new Customer().run();
    }

}
