#!/bin/sh

echo "------------------------------------------------------------"
echo "- La programmation orientee aspect pour Java/J2EE          -"
echo "- Renaud Pawlak, Jean-Philippe Retaille, Lionel Seinturier -"
echo "- Editions Eyrolles                                        -"
echo "-                                                          -"
echo "- Partie III  : Applications de la POA                        -"
echo "- Chapitre 8 : Design patterns et POA                                     -"
echo "------------------------------------------------------------"

echo "------------------------------------"
echo "- Configuration de l'environnement -"
echo "------------------------------------"

if [ "$JAVA_HOME" = "" ] ; then JAVA_HOME=/share/softs/j2sdk1.4.1
fi
if [ "$ASPECTJ_HOME" = "" ] ; then ASPECTJ_HOME=/share/softs/aspectj1.1.1
fi

echo "JAVA_HOME=$JAVA_HOME"
echo "ASPECTJ_HOME=$ASPECTJ_HOME"

if [ -f $JAVA_HOME/bin/java ]
then
    if [ -f $ASPECTJ_HOME/lib/aspectjtools.jar -a -f $ASPECTJ_HOME/lib/aspectjrt.jar ]
    then
        echo
    else
        echo "AspectJ n'a pas ete trouve."
        echo "Positionner la variable d'environnement ASPECTJ_HOME dans le fichier env.sh"
    fi
else
    echo "Java n'a pas ete trouve."
    echo "Positionner la variable d'environnement JAVA_HOME dans le fichier env.sh"
fi
