// ------------------------------------------------------------
// - La programmation orientee aspect pour Java/J2EE          -
// - Renaud Pawlak, Jean-Philippe Retaille, Lionel Seinturier -
// - Editions Eyrolles                                        -
// -                                                          -
// - Partie III  : Applications de la POA                     -
// - Chapitre 10 : Serveurs d'applications et POA             -
// ------------------------------------------------------------

package aop.as.persistence;

import aop.as.hibernate.Persistent;

/**
 * Classe reprsentant une commande
 * 
 * @author Renaud Pawlak
 * @author Jean-Philippe Retaille
 * @author Lionel Seinturier
 */
public class Order implements Persistent {
	private int id;
	private String item;
	private int quantity;
	private Customer customer;
		
	public Order() {
	}
	
	public Order(int id) {
		this.id = id;
	}
	
	public Customer getCustomer() {
		return customer;
	}

	public int getId() {
		return id;
	}

	public String getItem() {
		return item;
	}

	public int getQuantity() {
		return quantity;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	public void setId(int id) {
		this.id = id;
	}

	public void setItem(String item) {
		this.item = item;
	}

	public void setQuantity(int quantity) {
		this.quantity = quantity;
	}
	
	public void delete() {
	}
	
	public void save() {
	}
}
